<?php declare(strict_types=1);

/*
 * Plugin Name: Cxense cce widget
 * Description: Display conversion engine widgets from cxense
 * Version: 0.1.2
 * Author: Infomaker Scandinavia AB
 * Author URI: https://infomaker.se
 */

namespace Everyware\Plugin\Cxense\Widgets;

use Everyware\ProjectPlugin\Components\Adapters\WidgetAdapter;
use Everyware\ProjectPlugin\Components\ComponentSettingsRepository;
use Everyware\ProjectPlugin\Components\Contracts\Admin;
use Everyware\ProjectPlugin\Components\SettingsProviders\SimpleSettingsProvider;
use Everyware\ProjectPlugin\Components\WidgetAdmin;
use Everyware\ProjectPlugin\Helpers\FileReader;
use Infomaker\Everyware\Twig\View;

class CCEWidget extends WidgetAdapter
{
    /**
     * @var array
     */
    protected static $fields = [
        'widget_id' => '',
    ];

    protected function widgetSetup(): Admin
    {
        return new WidgetAdmin(
            new CCEForm(new FileReader(__FILE__)),
            new ComponentSettingsRepository(new SimpleSettingsProvider(static::$fields))
        );
    }

    /**
     * @param array $viewData
     * @param array $args
     *
     * @return string
     */
    protected function generateWidget(array $viewData, array $args): string
    {
        return View::generate('@cxense/widgets/cce/widget', array_replace($viewData, [
            'args' => $args,
            'target_id' => uniqid('cx_') . '_' . $viewData['widget_id']
        ]));
    }
}
